# EA.py

print("Enterprise Architect with PYTHON...")

from singleton_decorator import singleton # https://pypi.org/project/singleton-decorator/ -> 'pip install singleton-decorator'
import time
import win32com.client # 'pip install pywin32'

@singleton
class Enterprise_Architect:
    def __init__(self):
        try:
            self._EA = win32com.client.DispatchEx("EA.App") # Kill EA instance in Windows 'Task Manager'
            print("Enterprise Architect instance created...")
            self._Repository = self._EA.Repository # models = self._Repository.models
            self._Repository.OpenFile("C:\\Users\\franc\\Desktop\\Age_classification.qea")
            print("'self._Repository.RepositoryType()': ",self._Repository.RepositoryType())
            print("Name of diagram: ",self._Repository.GetDiagramByGuid("{53E40320-B104-4c1f-9243-70E3E1D471B1}").Name) # GUID of 'Age_classification' diagram: {53E40320-B104-4c1f-9243-70E3E1D471B1}
            time.sleep(1)
            self._Repository.CloseFile()
            self._Repository.Exit()
            print("Enterprise Architect instance stopped... No effect? -> kill EA instance in Windows 'Task Manager'")
        except Exception as e:
            print(e)

    @classmethod
    def Get_instance(file_URL):
        repository = win32com.client.GetActiveObject("EA.App").Repository # EA instance is already running...
        repository.CreateObject("EA.Repository")
        repository.OpenFile(file_URL)
        time.sleep(1)
        repository.CloseFile()
        repository.Exit()
        return None

ea = Enterprise_Architect() # creates instance
ea_ = Enterprise_Architect() # returns same instance because of '@singleton'
print(ea == ea_) # 'True'

